## diffname boot/boot.h 1992/0317
## diff -e /dev/null /n/bootesdump/1992/0317/sys/src/9/boot/boot.h
0a
typedef struct Method	Method;
struct Method
{
	char	*name;
	void	(*config)(Method*);
	void	(*auth)(Method*);
	void	(*connect)(Method*);
	char	*arg;
};

extern char	terminal[NAMELEN];
extern char	sys[2*NAMELEN];
extern char	password[NAMELEN];
extern char	username[NAMELEN];
extern char	cputype[NAMELEN];
extern char	*bootdisk;
extern char	*initflag;
extern void	(*pword)(Method*);
extern int	kflag;

/* libc equivalent */
extern int	plumb(char*, char*, int*, char*);
extern int	outin(char*, char*, int);
extern int	sendmsg(int, char*);
extern void	warning(char*);
extern void	fatal(char*);
extern int	readenv(char*, char*, int);
extern void	setenv(char*, char*);
extern void	srvcreate(char*, int);
extern int	dkauth(void);
extern int	dkconnect(void);
extern void	userpasswd(int);
extern void	getpasswd(char*, int);

/* methods */
extern void	config9600(Method*);
extern int	auth9600(Method*);
extern int	connect9600(Method*);
extern void	config192000(Method*);
extern int	auth192000(Method*);
extern int	connect192000(Method*);
extern void	confighs(Method*);
extern int	authhs(Method*);
extern int	connecths(Method*);
extern void	configincon(Method*);
extern int	authincon(Method*);
extern int	connectincon(Method*);
extern void	configil(Method*);
extern int	authil(Method*);
extern int	connectil(Method*);
extern void	configtcp(Method*);
extern int	authtcp(Method*);
extern int	connecttcp(Method*);
extern void	configcyc(Method*);
extern int	authcyc(Method*);
extern int	connectcyc(Method*);
extern void	configlocal(Method*);
extern int	authlocal(Method*);
extern int	connectlocal(Method*);
.
## diffname boot/boot.h 1992/0318
## diff -e /n/bootesdump/1992/0317/sys/src/9/boot/boot.h /n/bootesdump/1992/0318/sys/src/9/boot/boot.h
58,59c
extern int	authlocal(void);
extern int	connectlocal(void);
.
55,56c
extern int	authcyc(void);
extern int	connectcyc(void);
.
52,53c
extern int	authtcp(void);
extern int	connecttcp(void);
.
49,50c
extern int	authil(void);
extern int	connectil(void);
.
46,47c
extern int	authincon(void);
extern int	connectincon(void);
.
43,44c
extern int	authhs(void);
extern int	connecths(void);
.
37,41c
extern int	auth9600(void);
extern int	connect9600(void);
extern void	config19200(Method*);
extern int	auth19200(void);
extern int	connect19200(void);
.
30,33c
extern void	userpasswd(int, Method*);
extern void	warning(char*);
.
28a
extern void	settime(int);
.
27a
extern int	sendmsg(int, char*);
extern void	session(int);
.
26a
extern void	getpasswd(char*, int);
extern void	key(int, Method*);
extern void	newkernel(void);
extern void	nop(int);
extern int	outin(char*, char*, int);
extern int	passtokey(char*, char*, int);
extern int	plumb(char*, char*, int*, char*);
.
22,25c
extern int	cache(int);
extern int	dkauth(void);
extern int	dkconnect(void);
.
19a
extern Method	method[];
extern char	password[NAMELEN];
extern void	(*pword)(int, Method*);
extern char	sys[2*NAMELEN];
extern char	terminal[NAMELEN];
extern char	username[NAMELEN];
.
16,18c
extern int	fflag;
.
11,14c
extern char*	bootdisk;
extern int	(*cfs)(int);
extern int	cpuflag;
.
6,7c
	int	(*auth)(void);
	int	(*connect)(void);
.
## diffname boot/boot.h 1992/0322
## diff -e /n/bootesdump/1992/0318/sys/src/9/boot/boot.h /n/bootesdump/1992/0322/sys/src/9/boot/boot.h
34d
## diffname boot/boot.h 1992/0325
## diff -e /n/bootesdump/1992/0322/sys/src/9/boot/boot.h /n/bootesdump/1992/0325/sys/src/9/boot/boot.h
22a
extern char	*sauth;
.
## diffname boot/boot.h 1992/0522
## diff -e /n/bootesdump/1992/0325/sys/src/9/boot/boot.h /n/bootesdump/1992/0522/sys/src/9/boot/boot.h
43a
extern void	boot(int, char **);
extern void	bboot(int, char **);
.
22a
extern char	bootfile[3*NAMELEN];
.
## diffname boot/boot.h 1992/0530
## diff -e /n/bootesdump/1992/0522/sys/src/9/boot/boot.h /n/bootesdump/1992/0530/sys/src/9/boot/boot.h
30a
extern void	getconffile(char*, char*);
.
23a
extern char	conffile[NAMELEN];
.
## diffname boot/boot.h 1992/0610
## diff -e /n/bootesdump/1992/0530/sys/src/9/boot/boot.h /n/bootesdump/1992/0610/sys/src/9/boot/boot.h
39c
extern int	readfile(char*, char*, int);
.
## diffname boot/boot.h 1992/0611
## diff -e /n/bootesdump/1992/0610/sys/src/9/boot/boot.h /n/bootesdump/1992/0611/sys/src/9/boot/boot.h
74a
extern void	configbri(Method*);
extern int	authbri(void);
extern int	connectbri(void);
.
62a
extern void	configcincon(Method*);
extern int	authcincon(void);
extern int	connectcincon(void);
.
## diffname boot/boot.h 1992/0909
## diff -e /n/bootesdump/1992/0611/sys/src/9/boot/boot.h /n/bootesdump/1992/0909/sys/src/9/boot/boot.h
80a
extern void	confighybrid(Method*);
extern int	authhybrid(void);
extern int	connecthybrid(void);
.
## diffname boot/boot.h 1993/0330
## diff -e /n/bootesdump/1992/0909/sys/src/9/boot/boot.h /n/bootesdump/1993/0330/sys/src/9/boot/boot.h
48a
extern void	doauthenticate(int, Method*);
.
46a
extern int	writefile(char*, char*, int);
.
39a
extern int	readn(int, char*, int);
.
28a
extern char*	checkkey(Method*, char*, char*);
.
23,25c
extern char	bootfile[];
extern char	conffile[];
extern int	afd;
.
20,21c
extern char	sys[];
extern uchar	hostkey[];
extern char	terminal[];
.
18d
14c
extern char	cputype[];
.
## diffname boot/boot.h 1993/0501
## diff -e /n/bootesdump/1993/0330/sys/src/9/boot/boot.h /n/fornaxdump/1993/0501/sys/src/brazil/boot/boot.h
43d
37c
extern int	nop(int);
.
## diffname boot/boot.h 1994/0311
## diff -e /n/fornaxdump/1993/0501/sys/src/brazil/boot/boot.h /n/fornaxdump/1994/0311/sys/src/brazil/boot/boot.h
24a
extern int	bargc;
extern char	*bargv[];
.
## diffname boot/boot.h 1994/0317
## diff -e /n/fornaxdump/1994/0311/sys/src/brazil/boot/boot.h /n/fornaxdump/1994/0317/sys/src/brazil/boot/boot.h
26c
extern char	*bargv[Nbarg];
.
24a
enum
{
	Nbarg=	16,
};
.
## diffname boot/boot.h 1996/0111
## diff -e /n/fornaxdump/1994/0317/sys/src/brazil/boot/boot.h /n/fornaxdump/1996/0111/sys/src/brazil/boot/boot.h
31d
## diffname boot/boot.h 1996/1225
## diff -e /n/fornaxdump/1996/0111/sys/src/brazil/boot/boot.h /n/fornaxdump/1996/1225/sys/src/brazil/boot/boot.h
46c
extern long	readn(int, void*, long);
.
## diffname boot/boot.h 1997/0213
## diff -e /n/fornaxdump/1996/1225/sys/src/brazil/boot/boot.h /n/emeliedump/1997/0213/sys/src/brazil/boot/boot.h
58a
extern void	configppp(Method*);
extern int	authppp(void);
extern int	connectppp(void);
.
## diffname boot/boot.h 1997/0327
## diff -e /n/emeliedump/1997/0213/sys/src/brazil/boot/boot.h /n/emeliedump/1997/0327/sys/src/brazil/boot/boot.h
89,94d
83,85d
59,76d
56a
extern int	parsefields(char*, char**, int, char*);
.
55d
41d
38d
35,36d
23,24d
21d
## diffname boot/boot.h 1999/0316
## diff -e /n/emeliedump/1997/0327/sys/src/brazil/boot/boot.h /n/emeliedump/1999/0316/sys/src/brazil/boot/boot.h
11a
extern char*	rootdir;
.
## diffname boot/boot.h 1999/0610
## diff -e /n/emeliedump/1999/0316/sys/src/brazil/boot/boot.h /n/emeliedump/1999/0610/sys/src/brazil/boot/boot.h
61a
extern void	configsac(Method*);
extern int	authsac(void);
extern int	connectsac(void);
.
## diffname boot/boot.h 2000/1107
## diff -e /n/emeliedump/1999/0610/sys/src/brazil/boot/boot.h /n/emeliedump/2000/1107/sys/src/9/boot/boot.h
25c
	Nbarg=	32,
.
## diffname boot/boot.h 2001/0119
## diff -e /n/emeliedump/2000/1107/sys/src/9/boot/boot.h /n/emeliedump/2001/0119/sys/src/9/boot/boot.h
35a
extern void glendakey(int, Method*);
.
## diffname boot/boot.h 2001/0214
## diff -e /n/emeliedump/2001/0119/sys/src/9/boot/boot.h /n/emeliedump/2001/0214/sys/src/9/boot/boot.h
17a
extern int pushfcall(int);
.
## diffname boot/boot.h 2001/0527
## diff -e /n/emeliedump/2001/0214/sys/src/9/boot/boot.h /n/emeliedump/2001/0527/sys/src/9/boot/boot.h
51a
extern int		old9p(int);
.
47c
extern void	setusername(int, Method*);
.
37,38d
26c
	Nbarg=	16,
.
23c
extern char	username[];
extern uchar	statbuf[STATMAX];
.
18d
## diffname boot/boot.h 2001/0819
## diff -e /n/emeliedump/2001/0527/sys/src/9/boot/boot.h /n/emeliedump/2001/0819/sys/src/9/boot/boot.h
65a

/* hack for passing authentication address */
extern char	*authaddr;
.
43c
extern void	settime(int, int);
.
10a
extern void	authentication(int);
.
6d
## diffname boot/boot.h 2001/0820
## diff -e /n/emeliedump/2001/0819/sys/src/9/boot/boot.h /n/emeliedump/2001/0820/sys/src/9/boot/boot.h
23,27c
extern uchar	statbuf[Statsz];
.
8a
enum
{
	Statsz=	256,
	Nbarg=	16,
};
.
## diffname boot/boot.h 2001/1215
## diff -e /n/emeliedump/2001/0820/sys/src/9/boot/boot.h /n/emeliedump/2001/1215/sys/src/9/boot/boot.h
66a

extern void	configpaq(Method*);
extern int	authpaq(void);
extern int	connectpaq(void);
.
63a

.
60a

.
57a

.
## diffname boot/boot.h 2002/0109
## diff -e /n/emeliedump/2001/1215/sys/src/9/boot/boot.h /n/emeliedump/2002/0109/sys/src/9/boot/boot.h
71,73c
extern void	configrc(Method*);
extern int	connectrc(void);
.
68d
64d
60d
56d
## diffname boot/boot.h 2002/0412
## diff -e /n/emeliedump/2002/0109/sys/src/9/boot/boot.h /n/emeliedump/2002/0412/sys/src/9/boot/boot.h
66a
extern void	configpaq(Method*);
extern int	connectpaq(void);

.
## diffname boot/boot.h 2002/0801
## diff -e /n/emeliedump/2002/0412/sys/src/9/boot/boot.h /n/emeliedump/2002/0801/sys/src/9/boot/boot.h
70,71c
extern void	configembed(Method*);
extern int	connectembed(void);
.
## diffname boot/boot.h 2002/1002
## diff -e /n/emeliedump/2002/0801/sys/src/9/boot/boot.h /n/emeliedump/2002/1002/sys/src/9/boot/boot.h
44c
extern void	settime(int, int, char*);
.
