## diffname carrera/mem.h 1993/0903
## diff -e /dev/null /n/fornaxdump/1993/0903/sys/src/brazil/carrera/mem.h
0a
/*
 * Memory and machine-specific definitions.  Used in C and assembler.
 */

/*
 * Sizes
 */

#define	BI2BY		8			/* bits per byte */
#define BI2WD		32			/* bits per word */
#define	BY2WD		4			/* bytes per word */
#define	BY2PG		4096			/* bytes per page */
#define	WD2PG		(BY2PG/BY2WD)		/* words per page */
#define	PGSHIFT		12			/* log(BY2PG) */
#define PGROUND(s)	(((s)+(BY2PG-1))&~(BY2PG-1))

#define	MAXMACH		4			/* max # cpus system can run */
#define KSTACK		4096			/* Size of kernel stack */

/*
 * Time
 */
#define HZ		100			/* clock frequency */
#define	MS2HZ		(1000/HZ)		/* millisec per clock tick */
#define	TK2SEC(t)	((t)/HZ)		/* ticks to seconds */
#define	TK2MS(t)	((t)*MS2HZ)		/* ticks to milliseconds */
#define	MS2TK(t)	((t)/MS2HZ)		/* milliseconds to ticks */

/*
 * CP0 registers
 */

#define INDEX		0
#define RANDOM		1
#define TLBPHYS0	2
#define TLBPHYS1	3
#define CONTEXT		4
#define PAGEMASK	5
#define WIRED		6
#define BADVADDR	8
#define COUNT		9
#define TLBVIRT		10
#define COMPARE		11
#define STATUS		12
#define CAUSE		13
#define EPC		14
#define	PRID		15
#define	CONFIG		16
#define	LLADDR		17
#define	WATCHLO		18
#define	WATCHHI		19
#define	CACHEECC	26
#define	CACHEERR	27
#define	TAGLO		28
#define	TAGHI		29
#define	ERROREPC	30

/*
 * M(STATUS) bits
 */
#define KMODEMASK	0x0000001f
#define IE		0x00000001
#define EXL		0x00000002
#define ERL		0x00000004
#define KSUPER		0x00000008
#define KUSER		0x00000010
#define INTMASK		0x0000ff00
#define INTR0		0x00000100
#define INTR1		0x00000200
#define INTR2		0x00000400
#define INTR3		0x00000800
#define INTR4		0x00001000
#define INTR5		0x00002000
#define INTR6		0x00004000
#define INTR7		0x00008000
#define ISC		0x00010000
#define SWC		0x00020000
#define CU1		0x20000000

/*
 * Traps
 */

#define	UTLBMISS	(KSEG0+0x000)
#define	XEXCEPTION	(KSEG0+0x80)
#define	CACHETRAP	(KSEG0+0x100)
#define	EXCEPTION	(KSEG0+0x180)

/*
 * Magic registers
 */

#define	USER		24		/* R24 is up-> */
#define	MACH		25		/* R25 is m-> */

/*
 * Fundamental addresses
 */
#define	MACHADDR	0x80005000	/* Mach structures */
/* Leave space below kmap for IO */
#define	KMAPADDR	0xE0040000
/* Sizeof(Ureg)+space for retpc & ur */
#define UREGSIZE	0xA0
#define	MACHP(n)	((Mach *)(MACHADDR+(n)*BY2PG))


/*
 * MMU
 */

#define PGSZ4K		(0x00<<13)
#define PGSZ256K	(0x3F<<13)
	
#define	KUSEG	0x00000000
#define KSEG0	0x80000000
#define KSEG1	0xA0000000
#define	KSEG2	0xC0000000
#define	KSEG3	0xE0000000
#define	KSEGM	0xE0000000	/* mask to check which seg */

#define PIDXSHFT	12
#define PIDX		(0x7<<PIDXSHFT)
#define KMAPSHIFT	15
#define NCOLOR		8
#define getcolor(a)	(((ulong)(a)>>PIDXSHFT)&7)

#define	PTEGLOBL	(1<<0)
#define	PTEVALID	(1<<1)
#define	PTEWRITE	(1<<2)
#define PTERONLY	0
#define PTEALGMASK	(7<<3)
#define PTEUNCACHED	(2<<3)
#define PTENONCOHER	(3<<3)
#define PTECOHERXCL	(4<<3)
#define PTECOHERXCLW	(5<<3)
#define PTECOHERUPDW	(6<<3)

#define	PTEPID(n)	(n)
#define TLBPID(n)	((n)&0xFF)
#define PTEMAPMEM	(1024*1024)	
#define	PTEPERTAB	(PTEMAPMEM/BY2PG)
#define STLBLOG		13
#define STLBSIZE	(1<<STLBLOG)
#define KPTELOG		8
#define KPTESIZE	(1<<KPTELOG)
#define SEGMAPSIZE	512

#define	NTLBPID	256	/* number of pids */
#define	NTLB	48	/* number of entries */
#define	TLBROFF	4	/* offset of first randomly indexed entry */

/*
 * Address spaces
 */

#define	UZERO	KUSEG			/* base of user address space */
#define	UTZERO	(UZERO+BY2PG)		/* first address in user text */
#define	USTKTOP	(KZERO-BY2PG)		/* byte just beyond user stack */
#define	TSTKTOP	(0xC0000000+USTKSIZE-BY2PG) /* top of temporary stack */
#define TSTKSIZ 100
#define	KZERO	KSEG0			/* base of kernel address space */
#define	KTZERO	(KZERO+0x20000)		/* first address in kernel text */
#define	USTKSIZE	(4*1024*1024)	/* size of user stack */
/*
 * Exception codes
 */
#define	EXCMASK	0x1f		/* mask of all causes */
#define	CINT	 0		/* external interrupt */
#define	CTLBM	 1		/* TLB modification */
#define	CTLBL	 2		/* TLB miss (load or fetch) */
#define	CTLBS	 3		/* TLB miss (store) */
#define	CADREL	 4		/* address error (load or fetch) */
#define	CADRES	 5		/* address error (store) */
#define	CBUSI	 6		/* bus error (fetch) */
#define	CBUSD	 7		/* bus error (data load or store) */
#define	CSYS	 8		/* system call */
#define	CBRK	 9		/* breakpoint */
#define	CRES	10		/* reserved instruction */
#define	CCPU	11		/* coprocessor unusable */
#define	COVF	12		/* arithmetic overflow */
#define	CTRAP	13		/* trap */
#define	CVCEI	14		/* virtual coherence exception (instruction) */
#define	CFPE	15		/* floating point exception */
#define	CWATCH	23		/* watch exception */
#define	CVCED	31		/* virtual coherence exception (data) */

#define isphys(x) (((ulong)x&KSEGM)==KSEG0 || ((ulong)x&KSEGM)==KSEG1)
.
## diffname carrera/mem.h 1993/0904
## diff -e /n/fornaxdump/1993/0903/sys/src/brazil/carrera/mem.h /n/fornaxdump/1993/0904/sys/src/brazil/carrera/mem.h
111a
#define PGSZ64K		(0x0F<<13)
.
## diffname carrera/mem.h 1993/0906
## diff -e /n/fornaxdump/1993/0904/sys/src/brazil/carrera/mem.h /n/fornaxdump/1993/0906/sys/src/brazil/carrera/mem.h
126c
#define getpgcolor(a)	(((ulong)(a)>>PIDXSHFT)&7)
.
123a
#define	KMAPADDR	0xE1000000
#define KMAPMASK	0xFF000000
.
110d
106d
100,103c
#define UREGSIZE	0xA0		/* Sizeof(Ureg)+retpc & ur */
.
92d
83d
81c
 * Trap vectors
.
## diffname carrera/mem.h 1993/0907
## diff -e /n/fornaxdump/1993/0906/sys/src/brazil/carrera/mem.h /n/fornaxdump/1993/0907/sys/src/brazil/carrera/mem.h
106a
#define PGSZ1M		(0xFF<<13)
.
## diffname carrera/mem.h 1993/0908
## diff -e /n/fornaxdump/1993/0907/sys/src/brazil/carrera/mem.h /n/fornaxdump/1993/0908/sys/src/brazil/carrera/mem.h
133a
#define IOPTE		(PTEGLOBL|PTEVALID|PTEWRITE|PTEUNCACHED)
.
## diffname carrera/mem.h 1993/0930
## diff -e /n/fornaxdump/1993/0908/sys/src/brazil/carrera/mem.h /n/fornaxdump/1993/0930/sys/src/brazil/carrera/mem.h
77a
#define CU0		0x10000000
.
## diffname carrera/mem.h 1993/1209
## diff -e /n/fornaxdump/1993/0930/sys/src/brazil/carrera/mem.h /n/fornaxdump/1993/1209/sys/src/brazil/carrera/mem.h
98c
#define	MACHADDR	0x8008e000	/* Mach structures */
.
## diffname carrera/mem.h 1993/1211
## diff -e /n/fornaxdump/1993/1209/sys/src/brazil/carrera/mem.h /n/fornaxdump/1993/1211/sys/src/brazil/carrera/mem.h
143c
#define KPTELOG		6
.
98c
#define	MACHADDR	(KTZERO-MAXMACH*BY2PG)	/* warning: rdbg is near here */
.
17c
#define	MAXMACH		1			/* max # cpus system can run */
.
## diffname carrera/mem.h 1993/1218
## diff -e /n/fornaxdump/1993/1211/sys/src/brazil/carrera/mem.h /n/fornaxdump/1993/1218/sys/src/brazil/carrera/mem.h
119c
#define	KMAPADDR	0xE2000000
.
## diffname carrera/mem.h 1993/1224
## diff -e /n/fornaxdump/1993/1218/sys/src/brazil/carrera/mem.h /n/fornaxdump/1993/1224/sys/src/brazil/carrera/mem.h
143c
#define KPTELOG		7
.
## diffname carrera/mem.h 1993/1230
## diff -e /n/fornaxdump/1993/1224/sys/src/brazil/carrera/mem.h /n/fornaxdump/1993/1230/sys/src/brazil/carrera/mem.h
162a
#define globalmem(x)	(((ulong)x)&KZERO)	/* addresses valid in all contexts */
.
## diffname carrera/mem.h 1994/0209
## diff -e /n/fornaxdump/1993/1230/sys/src/brazil/carrera/mem.h /n/fornaxdump/1994/0209/sys/src/brazil/carrera/mem.h
159c
#define	TSTKSIZ 100
.
141,145c
#define	STLBLOG		13
#define	STLBSIZE	(1<<STLBLOG)
#define	KPTELOG		7
#define	KPTESIZE	(1<<KPTELOG)
#define	SEGMAPSIZE	512
.
138,139c
#define	TLBPID(n)	((n)&0xFF)
#define	PTEMAPMEM	(1024*1024)	
.
128,135c
#define	PTERONLY	0
#define	PTEALGMASK	(7<<3)
#define	PTEUNCACHED	(2<<3)
#define	PTENONCOHER	(3<<3)
#define	PTECOHERXCL	(4<<3)
#define	PTECOHERXCLW	(5<<3)
#define	PTECOHERUPDW	(6<<3)
#define	IOPTE		(PTEGLOBL|PTEVALID|PTEWRITE|PTEUNCACHED)
.
120,123c
#define	KMAPMASK	0xFF000000
#define	KMAPSHIFT	15
#define	NCOLOR		8
#define	getpgcolor(a)	(((ulong)(a)>>PIDXSHFT)&7)
.
117,118c
#define	PIDXSHFT	12
#define	PIDX		(0x7<<PIDXSHFT)
.
111,112c
#define	KSEG0	0x80000000
#define	KSEG1	0xA0000000
.
105,108c
#define	PGSZ4K		(0x00<<13)
#define	PGSZ64K		(0x0F<<13)
#define	PGSZ256K	(0x3F<<13)
#define	PGSZ1M		(0xFF<<13)
.
99c
#define	UREGSIZE	0xC0		/* Sizeof(Ureg)+R5,R6+16 bytes slop+retpc & ur */
.
23c
#define	HZ		100			/* clock frequency */
.
18c
#define	KSTACK		4096			/* Size of kernel stack */
.
15c
#define	PGROUND(s)	(((s)+(BY2PG-1))&~(BY2PG-1))
.
10c
#define	BI2WD		32			/* bits per word */
.
## diffname carrera/mem.h 1994/0210
## diff -e /n/fornaxdump/1994/0209/sys/src/brazil/carrera/mem.h /n/fornaxdump/1994/0210/sys/src/brazil/carrera/mem.h
149c
#define	TLBROFF	5	/* offset of first randomly indexed entry */
.
119c
#define	KMAPADDR	0xE4000000
.
109c
#define	PGSZ4M		(0x3FF<<13)

.
99c
/* Sizeof(Ureg)+R5,R6+16 bytes slop+retpc & ur */
#define	UREGSIZE	0xC0		
.
## diffname carrera/mem.h 1994/0306
## diff -e /n/fornaxdump/1994/0210/sys/src/brazil/carrera/mem.h /n/fornaxdump/1994/0306/sys/src/brazil/carrera/mem.h
11a
#define BY2V		8			/* bytes per vlong */
.
## diffname carrera/mem.h 1994/0322
## diff -e /n/fornaxdump/1994/0306/sys/src/brazil/carrera/mem.h /n/fornaxdump/1994/0322/sys/src/brazil/carrera/mem.h
16c
#define ROUND(s, sz)	(((s)+(sz-1))&~(sz-1))
#define PGROUND(s)	ROUND(s, BY2PG)
.
## diffname carrera/mem.h 1994/0522
## diff -e /n/fornaxdump/1994/0322/sys/src/brazil/carrera/mem.h /n/fornaxdump/1994/0522/sys/src/brazil/carrera/mem.h
165c
#define	KTZERO	(KZERO+0x2000)		/* first address in kernel text */
.
78,79c
#define DE		0x00010000
#define BEV		0x00400000
.
## diffname carrera/mem.h 1994/0524
## diff -e /n/fornaxdump/1994/0522/sys/src/brazil/carrera/mem.h /n/fornaxdump/1994/0524/sys/src/brazil/carrera/mem.h
165c
#define	KTZERO	(KZERO+0x12000)		/* first address in kernel text */
.
## diffname carrera/mem.h 1994/0609
## diff -e /n/fornaxdump/1994/0524/sys/src/brazil/carrera/mem.h /n/fornaxdump/1994/0609/sys/src/brazil/carrera/mem.h
101,102c
/* Sizeof(Ureg)+retpc & ur+16 bytes slop */
#define	UREGSIZE	(36*8 + 2*4 + 2*4 + 16)
#define	Uoffset		8

#define	Ureg_status	(Uoffset+0)
#define	Ureg_cause	(Uoffset+4)
#define	Ureg_pc		(Uoffset+8)
#define	Ureg_sp		(Uoffset+16)
#define	Ureg_badvaddr	(Uoffset+24)
#define	Ureg_tlbvirt	(Uoffset+32)
#define	Ureg_hi		(Uoffset+40)
#define	Ureg_lo		(Uoffset+48)
#define	Ureg_r31	(Uoffset+56)
#define	Ureg_r30	(Uoffset+64)
#define	Ureg_r28	(Uoffset+72)
#define	Ureg_r27	(Uoffset+80)
#define	Ureg_r26	(Uoffset+88)
#define	Ureg_r25	(Uoffset+96)
#define	Ureg_r24	(Uoffset+104)
#define	Ureg_r23	(Uoffset+112)
#define	Ureg_r22	(Uoffset+120)
#define	Ureg_r21	(Uoffset+128)
#define	Ureg_r20	(Uoffset+136)
#define	Ureg_r19	(Uoffset+144)
#define	Ureg_r18	(Uoffset+152)
#define	Ureg_r17	(Uoffset+160)
#define	Ureg_r16	(Uoffset+168)
#define	Ureg_r15	(Uoffset+176)
#define	Ureg_r14	(Uoffset+184)
#define	Ureg_r13	(Uoffset+192)
#define	Ureg_r12	(Uoffset+200)
#define	Ureg_r11	(Uoffset+208)
#define	Ureg_r10	(Uoffset+216)
#define	Ureg_r9		(Uoffset+224)
#define	Ureg_r8		(Uoffset+232)
#define	Ureg_r7		(Uoffset+240)
#define	Ureg_r6		(Uoffset+248)
#define	Ureg_r5		(Uoffset+256)
#define	Ureg_r4		(Uoffset+264)
#define	Ureg_r3		(Uoffset+272)
#define	Ureg_r2		(Uoffset+280)
#define	Ureg_r1		(Uoffset+288)
.
68a
#define UX		0x00000020
.
## diffname carrera/mem.h 1994/0610
## diff -e /n/fornaxdump/1994/0609/sys/src/brazil/carrera/mem.h /n/fornaxdump/1994/0610/sys/src/brazil/carrera/mem.h
102,143c
/* Sizeof(Ureg)+R5,R6+16 bytes slop+retpc & ur */
#define	UREGSIZE	0xC0		
.
## diffname carrera/mem.h 1994/0611
## diff -e /n/fornaxdump/1994/0610/sys/src/brazil/carrera/mem.h /n/fornaxdump/1994/0611/sys/src/brazil/carrera/mem.h
69d
## diffname carrera/mem.h 1994/0612
## diff -e /n/fornaxdump/1994/0611/sys/src/brazil/carrera/mem.h /n/fornaxdump/1994/0612/sys/src/brazil/carrera/mem.h
103a

/*
 * offsets in ureg.h for l.s
 */
#define	Ureg_status	(Uoffset+0)
#define	Ureg_pc		(Uoffset+4)
#define	Ureg_sp		(Uoffset+8)
#define	Ureg_cause	(Uoffset+12)
#define	Ureg_badvaddr	(Uoffset+16)
#define	Ureg_tlbvirt	(Uoffset+20)

#define	Ureg_hi		(Uoffset+28-4)
#define	Ureg_lo		(Uoffset+36-4)
#define	Ureg_r31	(Uoffset+44-4)
#define	Ureg_r30	(Uoffset+52-4)
#define	Ureg_r28	(Uoffset+60-4)
#define	Ureg_r27	(Uoffset+68-4)
#define	Ureg_r26	(Uoffset+76-4)
#define	Ureg_r25	(Uoffset+84-4)
#define	Ureg_r24	(Uoffset+92-4)
#define	Ureg_r23	(Uoffset+100-4)
#define	Ureg_r22	(Uoffset+108-4)
#define	Ureg_r21	(Uoffset+116-4)
#define	Ureg_r20	(Uoffset+124-4)
#define	Ureg_r19	(Uoffset+132-4)
#define	Ureg_r18	(Uoffset+140-4)
#define	Ureg_r17	(Uoffset+148-4)
#define	Ureg_r16	(Uoffset+156-4)
#define	Ureg_r15	(Uoffset+164-4)
#define	Ureg_r14	(Uoffset+172-4)
#define	Ureg_r13	(Uoffset+180-4)
#define	Ureg_r12	(Uoffset+188-4)
#define	Ureg_r11	(Uoffset+196-4)
#define	Ureg_r10	(Uoffset+204-4)
#define	Ureg_r9		(Uoffset+212-4)
#define	Ureg_r8		(Uoffset+220-4)
#define	Ureg_r7		(Uoffset+228-4)
#define	Ureg_r6		(Uoffset+236-4)
#define	Ureg_r5		(Uoffset+244-4)
#define	Ureg_r4		(Uoffset+252-4)
#define	Ureg_r3		(Uoffset+260-4)
#define	Ureg_r2		(Uoffset+268-4)
#define	Ureg_r1		(Uoffset+276-4)

/* Sizeof(Ureg) + (R5,R6) + 16 bytes slop + retpc + ur */
#define	UREGSIZE	((Ureg_r1+8-Uoffset) + 16 + 16 + 4 + 4)
#define	Uoffset		8
.
101,102d
68a
#define UX		0x00000020
.
## diffname carrera/mem.h 1994/0614
## diff -e /n/fornaxdump/1994/0612/sys/src/brazil/carrera/mem.h /n/fornaxdump/1994/0614/sys/src/brazil/carrera/mem.h
148c
#define	UREGSIZE	((Ureg_r1+4-Uoffset) + 16 + 16 + 4 + 4)
.
113,146c
#define	Ureg_hi		(Uoffset+28)
#define	Ureg_lo		(Uoffset+36)
#define	Ureg_r31	(Uoffset+44)
#define	Ureg_r30	(Uoffset+52)
#define	Ureg_r28	(Uoffset+60)
#define	Ureg_r27	(Uoffset+68)
#define	Ureg_r26	(Uoffset+76)
#define	Ureg_r25	(Uoffset+84)
#define	Ureg_r24	(Uoffset+92)
#define	Ureg_r23	(Uoffset+100)
#define	Ureg_r22	(Uoffset+108)
#define	Ureg_r21	(Uoffset+116)
#define	Ureg_r20	(Uoffset+124)
#define	Ureg_r19	(Uoffset+132)
#define	Ureg_r18	(Uoffset+140)
#define	Ureg_r17	(Uoffset+148)
#define	Ureg_r16	(Uoffset+156)
#define	Ureg_r15	(Uoffset+164)
#define	Ureg_r14	(Uoffset+172)
#define	Ureg_r13	(Uoffset+180)
#define	Ureg_r12	(Uoffset+188)
#define	Ureg_r11	(Uoffset+196)
#define	Ureg_r10	(Uoffset+204)
#define	Ureg_r9		(Uoffset+212)
#define	Ureg_r8		(Uoffset+220)
#define	Ureg_r7		(Uoffset+228)
#define	Ureg_r6		(Uoffset+236)
#define	Ureg_r5		(Uoffset+244)
#define	Ureg_r4		(Uoffset+252)
#define	Ureg_r3		(Uoffset+260)
#define	Ureg_r2		(Uoffset+268)
#define	Ureg_r1		(Uoffset+276)
.
## diffname carrera/mem.h 1994/0617
## diff -e /n/fornaxdump/1994/0614/sys/src/brazil/carrera/mem.h /n/fornaxdump/1994/0617/sys/src/brazil/carrera/mem.h
103,147d
101a
/* Sizeof(Ureg)+R5,R6+16 bytes slop+retpc & ur */
#define	UREGSIZE	0xC0		
.
69d
## diffname carrera/mem.h 1994/0619
## diff -e /n/fornaxdump/1994/0617/sys/src/brazil/carrera/mem.h /n/fornaxdump/1994/0619/sys/src/brazil/carrera/mem.h
103a

/*
 * offsets in ureg.h for l.s
 */
#define	Ureg_status	(Uoffset+0)
#define	Ureg_pc		(Uoffset+4)
#define	Ureg_sp		(Uoffset+8)
#define	Ureg_cause	(Uoffset+12)
#define	Ureg_badvaddr	(Uoffset+16)
#define	Ureg_tlbvirt	(Uoffset+20)

#define	Ureg_hi		(Uoffset+28)
#define	Ureg_lo		(Uoffset+36)
#define	Ureg_r31	(Uoffset+44)
#define	Ureg_r30	(Uoffset+52)
#define	Ureg_r28	(Uoffset+60)
#define	Ureg_r27	(Uoffset+68)
#define	Ureg_r26	(Uoffset+76)
#define	Ureg_r25	(Uoffset+84)
#define	Ureg_r24	(Uoffset+92)
#define	Ureg_r23	(Uoffset+100)
#define	Ureg_r22	(Uoffset+108)
#define	Ureg_r21	(Uoffset+116)
#define	Ureg_r20	(Uoffset+124)
#define	Ureg_r19	(Uoffset+132)
#define	Ureg_r18	(Uoffset+140)
#define	Ureg_r17	(Uoffset+148)
#define	Ureg_r16	(Uoffset+156)
#define	Ureg_r15	(Uoffset+164)
#define	Ureg_r14	(Uoffset+172)
#define	Ureg_r13	(Uoffset+180)
#define	Ureg_r12	(Uoffset+188)
#define	Ureg_r11	(Uoffset+196)
#define	Ureg_r10	(Uoffset+204)
#define	Ureg_r9		(Uoffset+212)
#define	Ureg_r8		(Uoffset+220)
#define	Ureg_r7		(Uoffset+228)
#define	Ureg_r6		(Uoffset+236)
#define	Ureg_r5		(Uoffset+244)
#define	Ureg_r4		(Uoffset+252)
#define	Ureg_r3		(Uoffset+260)
#define	Ureg_r2		(Uoffset+268)
#define	Ureg_r1		(Uoffset+276)

/* Sizeof(Ureg) + (R5,R6) + 16 bytes slop + retpc + ur */
#define	UREGSIZE	((Ureg_r1+4-Uoffset) + 16 + 16 + 4 + 4)
#define	Uoffset		8
.
101,102d
87c
#define	XEXCEPTION	(KSEG0+0x080)
.
68a
#define UX		0x00000020
.
## diffname carrera/mem.h 1995/0115
## diff -e /n/fornaxdump/1994/0619/sys/src/brazil/carrera/mem.h /n/fornaxdump/1995/0115/sys/src/brazil/carrera/mem.h
96c
#define	MACH	25		/* R25 is m-> */
.
69a
#define SX		0x00000040
#define KX		0x00000080
.
68a
#define KSU		0x00000018
.
## diffname carrera/mem.h 1995/0117
## diff -e /n/fornaxdump/1995/0115/sys/src/brazil/carrera/mem.h /n/fornaxdump/1995/0117/sys/src/brazil/carrera/mem.h
168a
#define	CACHELINESZ	128
.
## diffname carrera/mem.h 1997/1103
## diff -e /n/fornaxdump/1995/0117/sys/src/brazil/carrera/mem.h /n/emeliedump/1997/1103/sys/src/brazil/carrera/mem.h
16,17c
#define 	ROUND(s, sz)	(((s)+(sz-1))&~(sz-1))
#define 	PGROUND(s)	ROUND(s, BY2PG)
.
12c
#define 	BY2V		8			/* bytes per vlong */
.
## diffname carrera/mem.h 1997/1208
## diff -e /n/emeliedump/1997/1103/sys/src/brazil/carrera/mem.h /n/emeliedump/1997/1208/sys/src/brazil/carrera/mem.h
216c
#define	USTKSIZE	(8*1024*1024)	/* size of user stack */
.
## diffname carrera/mem.h 1998/0610
## diff -e /n/emeliedump/1997/1208/sys/src/brazil/carrera/mem.h /n/emeliedump/1998/0610/sys/src/brazil/carrera/mem.h
25c
#define	HZ		1000			/* clock frequency */
.
## diffname carrera/mem.h 1998/0916
## diff -e /n/emeliedump/1998/0610/sys/src/brazil/carrera/mem.h /n/emeliedump/1998/0916/sys/src/brazil/carrera/mem.h
199a
#define SSEGMAPSIZE	16
.
## diffname carrera/mem.h 1999/0101
## diff -e /n/emeliedump/1998/0916/sys/src/brazil/carrera/mem.h /n/emeliedump/1999/0101/sys/src/brazil/carrera/mem.h
16c
#define ROUND(s, sz)	(((s)+((sz)-1))&~((sz)-1))
.
## diffname carrera/mem.h 1999/0327
## diff -e /n/emeliedump/1999/0101/sys/src/brazil/carrera/mem.h /n/emeliedump/1999/0327/sys/src/brazil/carrera/mem.h
25c
#define	HZ		250			/* clock frequency */
.
## diffname carrera/mem.h 1999/0331
## diff -e /n/emeliedump/1999/0327/sys/src/brazil/carrera/mem.h /n/emeliedump/1999/0331/sys/src/brazil/carrera/mem.h
25c
#define	HZ		500			/* clock frequency */
.
## diffname carrera/mem.h 1999/0402
## diff -e /n/emeliedump/1999/0331/sys/src/brazil/carrera/mem.h /n/emeliedump/1999/0402/sys/src/brazil/carrera/mem.h
25c
#define	HZ		1000			/* clock frequency */
.
## diffname carrera/mem.h 1999/0522
## diff -e /n/emeliedump/1999/0402/sys/src/brazil/carrera/mem.h /n/emeliedump/1999/0522/sys/src/brazil/carrera/mem.h
20a
#define BLOCKALIGN	8
.
## diffname carrera/mem.h 1999/1005
## diff -e /n/emeliedump/1999/0522/sys/src/brazil/carrera/mem.h /n/emeliedump/1999/1005/sys/src/brazil/carrera/mem.h
26c
#define	HZ		100			/* clock frequency */
.
## diffname carrera/mem.h 2000/0726
## diff -e /n/emeliedump/1999/1005/sys/src/brazil/carrera/mem.h /n/emeliedump/2000/0726/sys/src/9/carrera/mem.h
30c
#define	MS2TK(t)	(((t)*HZ+500)/1000)	/* milliseconds to closest tick */
.
## diffname carrera/mem.h 2001/0527 # deleted
## diff -e /n/emeliedump/2000/0726/sys/src/9/carrera/mem.h /n/emeliedump/2001/0527/sys/src/9/carrera/mem.h
1,243d
