## diffname gnot/lib.h 1990/03091
## diff -e /dev/null /n/bootesdump/1990/03091/sys/src/9/68020/lib.h
0a
/*
 * functions (possibly) linked in, complete, from libc.
 */

/*
 * mem routines
 */
extern	void	*memccpy(void*, void*, int, long);
extern	void	*memset(void*, int, long);
extern	int	memcmp(void*, void*, long);
extern	void	*memcpy(void*, void*, long);
extern	void	*memchr(void*, int, long);

/*
 * string routines
 */
extern	char	*strcat(char*, char*);
extern	char	*strchr(char*, char);
extern	int	strcmp(char*, char*);
extern	char	*strcpy(char*, char*);
extern	char	*strncat(char*, char*, long);
extern	char	*strncpy(char*, char*, long);
extern	int	strncmp(char*, char*, long);
extern	long	strlen(char*);

/*
 * print routines
 */

#define	FUNSIGN	4
#define	FSHORT	2
#define	FLONG	1

typedef struct Op	Op;
struct Op
{
	char	*p;
	char	*ep;
	void	*argp;
	int	f1;
	int	f2;
	int	f3;
};
extern	void	strconv(char*, Op*, int, int);
extern	int	numbconv(Op*, int);
extern	char	*donprint(char*, char*, char*, void*);
extern	int	fmtinstall(char, int (*)(Op*));
extern	int	sprint(char*, char*, ...);
extern	int	print(char*, ...);

/*
 * one-of-a-kind
 */
extern	long	strtol(char*, char**, int);
extern	ulong	strtoul(char*, char**, int);
extern	long	end;

/*
 * Syscall data structures
 */

#define	MORDER	0x0003	/* mask for bits defining order of mounting */
#define	MREPL	0x0000	/* mount replaces object */
#define	MBEFORE	0x0001	/* mount goes before others in union directory */
#define	MAFTER	0x0002	/* mount goes after others in union directory */
#define	MCREATE	0x0004	/* permit creation in mounted directory */
#define	MMASK	0x0007	/* all bits on */

#define	OREAD	0	/* open for read */
#define	OWRITE	1	/* write */
#define	ORDWR	2	/* read and write */
#define	OEXEC	3	/* execute, == read but check execute permission */
#define	OTRUNC	16	/* or'ed in (except for exec), truncate file first */

typedef struct Error	Error;
typedef struct Dir	Dir;
typedef struct Waitmsg	Waitmsg;

struct Error
{
	int	type;
	int	dev;
	int	code;
};

#define	ERRLEN	64
#define	DIRLEN	64
#define	NAMELEN	28
struct Dir
{
	char	name[NAMELEN];
	long	qid;
	long	mode;
	long	atime;
	long	mtime;
	Length;
	short	uid;
	short	gid;
	short	type;
	short	dev;
};

struct Waitmsg
{
	int	pid;		/* of loved one */
	int	status;		/* unused; a placeholder */
	ulong	time[3];	/* of loved one */
	char	msg[ERRLEN];
};
.
## diffname gnot/lib.h 1990/06111
## diff -e /n/bootesdump/1990/03091/sys/src/9/68020/lib.h /n/bootesdump/1990/06111/sys/src/9/68020/lib.h
46c
extern	char	*doprint(char*, char*, char*, void*);
.
## diffname gnot/lib.h 1990/08141
## diff -e /n/bootesdump/1990/06111/sys/src/9/68020/lib.h /n/bootesdump/1990/08141/sys/src/9/68020/lib.h
73a
#define	OCEXEC	32	/* or'ed in, close on exec */
#define	ORCLOSE	64	/* or'ed in, remove on close */
.
## diffname gnot/lib.h 1990/11211
## diff -e /n/bootesdump/1990/08141/sys/src/9/68020/lib.h /n/bootesdump/1990/11211/sys/src/9/68020/lib.h
99,100d
94,95c
	char	uid[NAMELEN];
	char	gid[NAMELEN];
	Qid	qid;
	ulong	mode;
.
88,90d
83,85c
	ulong	path;
	ulong	vers;
.
81c
#define	ERRLEN	64
#define	DIRLEN	116
#define	NAMELEN	28

struct Qid
.
77c
typedef struct Qid	Qid;
.
## diffname gnot/lib.h 1991/0318
## diff -e /n/bootesdump/1991/0201/sys/src/9/68020/lib.h /n/bootesdump/1991/0318/sys/src/9/gnot/lib.h
11c
extern	void	*memmove(void*, void*, long);
.
## diffname gnot/lib.h 1991/0717
## diff -e /n/bootesdump/1991/0318/sys/src/9/gnot/lib.h /n/bootesdump/1991/0717/sys/src/9/gnot/lib.h
76a
#define	NCONT	0	/* continue after note */
#define	NTERM	1	/* terminate after note */

.
## diffname gnot/lib.h 1991/0718
## diff -e /n/bootesdump/1991/0717/sys/src/9/gnot/lib.h /n/bootesdump/1991/0718/sys/src/9/gnot/lib.h
78c
#define	NDFLT	1	/* terminate after note */
.
## diffname gnot/lib.h 1991/1007
## diff -e /n/bootesdump/1991/0718/sys/src/9/gnot/lib.h /n/bootesdump/1991/1007/sys/src/9/gnot/lib.h
57d
55a
extern	long	etext;
extern	long	edata;
.
24a
extern	int	atoi(char*);
.
## diffname gnot/lib.h 1991/1207
## diff -e /n/bootesdump/1991/1007/sys/src/9/gnot/lib.h /n/bootesdump/1991/1207/sys/src/9/gnot/lib.h
86,88c
#define	ERRLEN		64
#define	DIRLEN		116
#define	NAMELEN		28
#define DESKEYLEN	7
.
## diffname gnot/lib.h 1991/1224
## diff -e /n/bootesdump/1991/1207/sys/src/9/gnot/lib.h /n/bootesdump/1991/1224/sys/src/9/gnot/lib.h
27a
 * rune routines
 */
extern	int	runetochar(char*, Rune*);
extern	int	chartorune(Rune*, char*);
extern	int	countrune(char*);

/*
.
## diffname gnot/lib.h 1992/0213
## diff -e /n/bootesdump/1991/1224/sys/src/9/gnot/lib.h /n/bootesdump/1992/0213/sys/src/9/gnot/lib.h
32a
extern	char*	utfrune(char*, long);
.
## diffname gnot/lib.h 1992/0309
## diff -e /n/bootesdump/1992/0213/sys/src/9/gnot/lib.h /n/bootesdump/1992/0309/sys/src/9/gnot/lib.h
121,123c
	char	pid[12];	/* of loved one */
	char	time[3*12];	/* of loved one and descendants */
.
## diffname gnot/lib.h 1992/0319
## diff -e /n/bootesdump/1992/0309/sys/src/9/gnot/lib.h /n/bootesdump/1992/0319/sys/src/9/gnot/lib.h
65,67c
extern	char	etext[];
extern	char	edata[];
extern	char	end[];
.
## diffname gnot/lib.h 1992/0321 # deleted
## diff -e /n/bootesdump/1992/0319/sys/src/9/gnot/lib.h /n/bootesdump/1992/0321/sys/src/9/gnot/lib.h
1,124d
