## diffname power/fcall.h 1990/0227
## diff -e /dev/null /n/bootesdump/1990/0227/sys/src/9/mips/fcall.h
0a
typedef	struct	Fcall	Fcall;

struct	Fcall
{
	char	type;
	short	fid;
	short	err;
	union
	{
		struct
		{
			short	uid;		/* T-Userstr */
			short	newfid;		/* T-Clone */
			char	lang;		/* T-Session */
			ulong	qid;		/* R-Attach, R-Walk, R-Open, R-Create */
		};
		struct
		{
			char	uname[28];	/* T-Attach, R-Userstr */
			char	aname[28];	/* T-Attach */
		};
		struct
		{
			char	ename[64];	/* R-Errstr */
		};
		struct
		{
			long	perm;		/* T-Create */ 
			char	name[28];	/* T-Walk, T-Create, T-Remove */
			char	mode;		/* T-Create, T-Open */
		};
		struct
		{
			long	offset;		/* T-Read, T-Write */
			long	count;		/* T-Read, T-Write, R-Read */
			char	*data;		/* T-Write, R-Read */
		};
		struct
		{
			char	stat[DIRLEN];	/* T-Wstat, R-Stat */
		};
	};
};

#define	MAXFDATA	8192

enum
{
	Tnop =		0,
	Rnop,
	Tsession =	2,
	Rsession,
	Tattach =	10,
	Rattach,
	Tclone =	12,
	Rclone,
	Twalk =		14,
	Rwalk,
	Topen =		16,
	Ropen,
	Tcreate =	18,
	Rcreate,
	Toread =	20,
	Roread,
	Towrite =	22,
	Rowrite,
	Tclunk =	24,
	Rclunk,
	Tremove =	26,
	Rremove,
	Tstat =		28,
	Rstat,
	Twstat =	30,
	Rwstat,
	Terrstr =	32,
	Rerrstr,
	Tuserstr =	34,
	Ruserstr,
	Tread =		36,
	Rread,
	Twrite =	38,
	Rwrite,
};

int	convM2S(char*, Fcall*, int);
int	convS2M(Fcall*, char*);

int	convM2D(char*, Dir*);
int	convD2M(Dir*, char*);
.
## diffname power/fcall.h 1990/11211
## diff -e /n/bootesdump/1990/0227/sys/src/9/mips/fcall.h /n/bootesdump/1990/11211/sys/src/9/mips/fcall.h
89a

int	fcallconv(void *, int, int, int, int);
int	dirconv(void *, int, int, int, int);
.
75,82d
73c
	Twstat =	78,
.
71c
	Tstat =		76,
.
69c
	Tremove =	74,
.
63,67c
	Tread =		68,
	Rread,
	Twrite =	70,
	Rwrite,
	Tclunk =	72,
.
61c
	Tcreate =	66,
.
59c
	Topen =		64,
.
57c
	Twalk =		62,
.
55c
	Tclone =	60,
.
53c
/*	Terror =	54,	illegal */
	Rerror =	55,
	Tflush =	56,
	Rflush,
	Tattach =	58,
.
51c
	Tsession =	52,
.
49c
	Tnop =		50,
.
29c
			char	name[NAMELEN];	/* T-Walk, T-Create */
.
24c
			char	ename[ERRLEN];	/* R-Error */
.
19,20c
			char	uname[NAMELEN];	/* T-Attach */
			char	aname[NAMELEN];	/* T-Attach */
			char	auth[NAMELEN];	/* T-Attach */
.
14,15c
			short	oldtag;		/* T-Flush */
			Qid	qid;		/* R-Attach, R-Walk, R-Open, R-Create */
.
12d
7c
	short	tag;
.
## diffname power/fcall.h 1991/0220 # deleted
## diff -e /n/bootesdump/1991/0201/sys/src/9/mips/fcall.h /n/bootesdump/1991/0220/sys/src/9/power/fcall.h
1,88d
